/*!
 * Copyright (c) 2016 Chris O'Hara <cohara87@gmail.com>
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.validator=t()}(this,function(){"use strict";function e(e){if("string"!=typeof e)throw new TypeError("This library (validator.js) validates strings only")}function t(t){return e(t),t=Date.parse(t),isNaN(t)?null:new Date(t)}function r(t){return e(t),parseFloat(t)}function n(t,r){return e(t),parseInt(t,r||10)}function i(t,r){return e(t),r?"1"===t||"true"===t:"0"!==t&&"false"!==t&&""!==t}function o(t,r){return e(t),t===r}function a(e){return"object"===("undefined"==typeof e?"undefined":pe(e))&&null!==e?e="function"==typeof e.toString?e.toString():"[object Object]":(null===e||"undefined"==typeof e||isNaN(e)&&!e.length)&&(e=""),String(e)}function u(t,r){return e(t),t.indexOf(a(r))>=0}function s(t,r,n){return e(t),"[object RegExp]"!==Object.prototype.toString.call(r)&&(r=new RegExp(r,n)),r.test(t)}function l(){var e=arguments.length<=0||void 0===arguments[0]?{}:arguments[0],t=arguments[1];for(var r in t)"undefined"==typeof e[r]&&(e[r]=t[r]);return e}function f(t,r){e(t);var n=void 0,i=void 0;"object"===("undefined"==typeof r?"undefined":pe(r))?(n=r.min||0,i=r.max):(n=arguments[1],i=arguments[2]);var o=encodeURI(t).split(/%..|./).length-1;return o>=n&&("undefined"==typeof i||o<=i)}function d(t,r){e(t),r=l(r,ge),r.allow_trailing_dot&&"."===t[t.length-1]&&(t=t.substring(0,t.length-1));var n=t.split(".");if(r.require_tld){var i=n.pop();if(!n.length||!/^([a-z\u00a1-\uffff]{2,}|xn[a-z0-9-]{2,})$/i.test(i))return!1}for(var o,a=0;a<n.length;a++){if(o=n[a],r.allow_underscores&&(o=o.replace(/_/g,"")),!/^[a-z\u00a1-\uffff0-9-]+$/i.test(o))return!1;if(/[\uff01-\uff5e]/.test(o))return!1;if("-"===o[0]||"-"===o[o.length-1])return!1}return!0}function c(t,r){if(e(t),r=l(r,Fe),r.allow_display_name){var n=t.match(ve);n&&(t=n[1])}var i=t.split("@"),o=i.pop(),a=i.join("@"),u=o.toLowerCase();if("gmail.com"!==u&&"googlemail.com"!==u||(a=a.replace(/\./g,"").toLowerCase()),!f(a,{max:64})||!f(o,{max:256}))return!1;if(!d(o,{require_tld:r.require_tld}))return!1;if('"'===a[0])return a=a.slice(1,a.length-1),r.allow_utf8_local_part?xe.test(a):he.test(a);for(var s=r.allow_utf8_local_part?$e:_e,c=a.split("."),p=0;p<c.length;p++)if(!s.test(c[p]))return!1;return!0}function p(t){var r=arguments.length<=1||void 0===arguments[1]?"":arguments[1];if(e(t),r=String(r),!r)return p(t,4)||p(t,6);if("4"===r){if(!Ae.test(t))return!1;var n=t.split(".").sort(function(e,t){return e-t});return n[3]<=255}if("6"===r){var i=t.split(":"),o=!1,a=p(i[i.length-1],4),u=a?7:8;if(i.length>u)return!1;if("::"===t)return!0;"::"===t.substr(0,2)?(i.shift(),i.shift(),o=!0):"::"===t.substr(t.length-2)&&(i.pop(),i.pop(),o=!0);for(var s=0;s<i.length;++s)if(""===i[s]&&s>0&&s<i.length-1){if(o)return!1;o=!0}else if(a&&s===i.length-1);else if(!me.test(i[s]))return!1;return o?i.length>=1:i.length===u}return!1}function g(e){return"[object RegExp]"===Object.prototype.toString.call(e)}function F(e,t){for(var r=0;r<t.length;r++){var n=t[r];if(e===n||g(n)&&n.test(e))return!0}return!1}function v(t,r){if(e(t),!t||t.length>=2083||/\s/.test(t))return!1;if(0===t.indexOf("mailto:"))return!1;r=l(r,we);var n=void 0,i=void 0,o=void 0,a=void 0,u=void 0,s=void 0,f=void 0,c=void 0;if(f=t.split("#"),t=f.shift(),f=t.split("?"),t=f.shift(),f=t.split("://"),f.length>1){if(n=f.shift(),r.require_valid_protocol&&r.protocols.indexOf(n)===-1)return!1}else{if(r.require_protocol)return!1;r.allow_protocol_relative_urls&&"//"===t.substr(0,2)&&(f[0]=t.substr(2))}if(t=f.join("://"),f=t.split("/"),t=f.shift(),""===t&&!r.require_host)return!0;if(f=t.split("@"),f.length>1&&(i=f.shift(),i.indexOf(":")>=0&&i.split(":").length>2))return!1;a=f.join("@"),s=c=null;var g=a.match(be);return g?(o="",c=g[1],s=g[2]||null):(f=a.split(":"),o=f.shift(),f.length&&(s=f.join(":"))),!(null!==s&&(u=parseInt(s,10),!/^[0-9]+$/.test(s)||u<=0||u>65535))&&(!!(p(o)||d(o,r)||c&&p(c,6)||"localhost"===o)&&(o=o||c,!(r.host_whitelist&&!F(o,r.host_whitelist))&&(!r.host_blacklist||!F(o,r.host_blacklist))))}function _(t){return e(t),ye.test(t)}function h(t){return e(t),["true","false","1","0"].indexOf(t)>=0}function $(t){var r=arguments.length<=1||void 0===arguments[1]?"en-US":arguments[1];if(e(t),r in De)return De[r].test(t);throw new Error("Invalid locale '"+r+"'")}function x(t){var r=arguments.length<=1||void 0===arguments[1]?"en-US":arguments[1];if(e(t),r in Se)return Se[r].test(t);throw new Error("Invalid locale '"+r+"'")}function A(t){return e(t),Ce.test(t)}function m(t){return e(t),t===t.toLowerCase()}function w(t){return e(t),t===t.toUpperCase()}function b(t){return e(t),Ne.test(t)}function y(t){return e(t),je.test(t)}function D(t){return e(t),Ue.test(t)}function S(t){return e(t),je.test(t)&&Ue.test(t)}function Z(t){return e(t),ze.test(t)}function E(t){return e(t),Be.test(t)}function I(t,r){e(t),r=r||{};var n=r.hasOwnProperty("allow_leading_zeroes")&&r.allow_leading_zeroes?Pe:Le,i=!r.hasOwnProperty("min")||t>=r.min,o=!r.hasOwnProperty("max")||t<=r.max;return n.test(t)&&i&&o}function O(t,r){return e(t),r=r||{},""!==t&&"."!==t&&(qe.test(t)&&(!r.hasOwnProperty("min")||t>=r.min)&&(!r.hasOwnProperty("max")||t<=r.max))}function R(t){return e(t),""!==t&&Te.test(t)}function C(t){return e(t),Me.test(t)}function N(t,n){return e(t),r(t)%parseInt(n,10)===0}function j(t){return e(t),He.test(t)}function U(t){return e(t),We.test(t)}function z(t){e(t);try{var r=JSON.parse(t);return!!r&&"object"===("undefined"==typeof r?"undefined":pe(r))}catch(e){}return!1}function B(t){return e(t),0===t.length}function L(t,r){e(t);var n=void 0,i=void 0;"object"===("undefined"==typeof r?"undefined":pe(r))?(n=r.min||0,i=r.max):(n=arguments[1],i=arguments[2]);var o=t.match(/[\uD800-\uDBFF][\uDC00-\uDFFF]/g)||[],a=t.length-o.length;return a>=n&&("undefined"==typeof i||a<=i)}function P(t){var r=arguments.length<=1||void 0===arguments[1]?"all":arguments[1];e(t);var n=Ye[r];return n&&n.test(t)}function q(t){return e(t),C(t)&&24===t.length}function T(t){return e(t),Ge.test(t)}function M(e){var t=e.match(Ge),r=void 0,n=void 0,i=void 0,o=void 0;if(t){if(r=t[21],!r)return t[12]?null:0;if("z"===r||"Z"===r)return 0;n=t[22],r.indexOf(":")!==-1?(i=parseInt(t[23],10),o=parseInt(t[24],10)):(i=0,o=parseInt(t[23],10))}else{if(e=e.toLowerCase(),r=e.match(/(?:\s|gmt\s*)(-|\+)(\d{1,4})(\s|$)/),!r)return e.indexOf("gmt")!==-1?0:null;n=r[1];var a=r[2];3===a.length&&(a="0"+a),a.length<=2?(i=0,o=parseInt(a,10)):(i=parseInt(a.slice(0,2),10),o=parseInt(a.slice(2,4),10))}return(60*i+o)*("-"===n?1:-1)}function H(t){e(t);var r=new Date(Date.parse(t));if(isNaN(r))return!1;var n=M(t);if(null!==n){var i=r.getTimezoneOffset()-n;r=new Date(r.getTime()+6e4*i)}var o=String(r.getDate()),a=void 0,u=void 0,s=void 0;return!(u=t.match(/(^|[^:\d])[23]\d([^T:\d]|$)/g))||(a=u.map(function(e){return e.match(/\d+/g)[0]}).join("/"),s=String(r.getFullYear()).slice(-2),a===o||a===s||(a===""+o/s||a===""+s/o))}function W(r){var n=arguments.length<=1||void 0===arguments[1]?String(new Date):arguments[1];e(r);var i=t(n),o=t(r);return!!(o&&i&&o>i)}function Y(r){var n=arguments.length<=1||void 0===arguments[1]?String(new Date):arguments[1];e(r);var i=t(n),o=t(r);return!!(o&&i&&o<i)}function G(t,r){e(t);var n=void 0;if("[object Array]"===Object.prototype.toString.call(r)){var i=[];for(n in r)({}).hasOwnProperty.call(r,n)&&(i[n]=a(r[n]));return i.indexOf(t)>=0}return"object"===("undefined"==typeof r?"undefined":pe(r))?r.hasOwnProperty(t):!(!r||"function"!=typeof r.indexOf)&&r.indexOf(t)>=0}function J(t){e(t);var r=t.replace(/[^0-9]+/g,"");if(!Je.test(r))return!1;for(var n=0,i=void 0,o=void 0,a=void 0,u=r.length-1;u>=0;u--)i=r.substring(u,u+1),o=parseInt(i,10),a?(o*=2,n+=o>=10?o%10+1:o):n+=o,a=!a;return!(n%10!==0||!r)}function K(t){if(e(t),!Ke.test(t))return!1;for(var r=t.replace(/[A-Z]/g,function(e){return parseInt(e,36)}),n=0,i=void 0,o=void 0,a=!0,u=r.length-2;u>=0;u--)i=r.substring(u,u+1),o=parseInt(i,10),a?(o*=2,n+=o>=10?o+1:o):n+=o,a=!a;return parseInt(t.substr(t.length-1),10)===(1e4-n)%10}function Q(t){var r=arguments.length<=1||void 0===arguments[1]?"":arguments[1];if(e(t),r=String(r),!r)return Q(t,10)||Q(t,13);var n=t.replace(/[\s-]+/g,""),i=0,o=void 0;if("10"===r){if(!Qe.test(n))return!1;for(o=0;o<9;o++)i+=(o+1)*n.charAt(o);if(i+="X"===n.charAt(9)?100:10*n.charAt(9),i%11===0)return!!n}else if("13"===r){if(!ke.test(n))return!1;for(o=0;o<12;o++)i+=Ve[o%2]*n.charAt(o);if(n.charAt(12)-(10-i%10)%10===0)return!!n}return!1}function k(t,r){return e(t),r in Xe&&Xe[r].test(t)}function V(e){var t="(\\"+e.symbol.replace(/\./g,"\\.")+")"+(e.require_symbol?"":"?"),r="-?",n="[1-9]\\d*",i="[1-9]\\d{0,2}(\\"+e.thousands_separator+"\\d{3})*",o=["0",n,i],a="("+o.join("|")+")?",u="(\\"+e.decimal_separator+"\\d{2})?",s=a+u;return e.allow_negatives&&!e.parens_for_negatives&&(e.negative_sign_after_digits?s+=r:e.negative_sign_before_digits&&(s=r+s)),e.allow_negative_sign_placeholder?s="( (?!\\-))?"+s:e.allow_space_after_symbol?s=" ?"+s:e.allow_space_after_digits&&(s+="( (?!$))?"),e.symbol_after_digits?s+=t:s=t+s,e.allow_negatives&&(e.parens_for_negatives?s="(\\("+s+"\\)|"+s+")":e.negative_sign_before_digits||e.negative_sign_after_digits||(s=r+s)),new RegExp("^(?!-? )(?=.*\\d)"+s+"$")}function X(t,r){return e(t),r=l(r,et),V(r).test(t)}function ee(t){e(t);var r=t.length;if(!r||r%4!==0||tt.test(t))return!1;var n=t.indexOf("=");return n===-1||n===r-1||n===r-2&&"="===t[r-1]}function te(t){return e(t),rt.test(t)}function re(t,r){e(t);var n=r?new RegExp("^["+r+"]+","g"):/^\s+/g;return t.replace(n,"")}function ne(t,r){e(t);for(var n=r?new RegExp("["+r+"]"):/\s/,i=t.length-1;i>=0&&n.test(t[i]);)i--;return i<t.length?t.substr(0,i+1):t}function ie(e,t){return ne(re(e,t),t)}function oe(t){return e(t),t.replace(/&/g,"&amp;").replace(/"/g,"&quot;").replace(/'/g,"&#x27;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\//g,"&#x2F;").replace(/`/g,"&#96;")}function ae(t){return e(t),t.replace(/&amp;/g,"&").replace(/&quot;/g,'"').replace(/&#x27;/g,"'").replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&#x2F;/g,"/").replace(/&#96;/g,"`")}function ue(t,r){return e(t),t.replace(new RegExp("["+r+"]+","g"),"")}function se(t,r){e(t);var n=r?"\\x00-\\x09\\x0B\\x0C\\x0E-\\x1F\\x7F":"\\x00-\\x1F\\x7F";return ue(t,n)}function le(t,r){return e(t),t.replace(new RegExp("[^"+r+"]+","g"),"")}function fe(t,r){e(t);for(var n=t.length-1;n>=0;n--)if(r.indexOf(t[n])===-1)return!1;return!0}function de(e,t){if(t=l(t,nt),!c(e))return!1;var r=e.split("@",2);if(r[1]=r[1].toLowerCase(),"gmail.com"===r[1]||"googlemail.com"===r[1]){if(t.remove_extension&&(r[0]=r[0].split("+")[0]),t.remove_dots&&(r[0]=r[0].replace(/\./g,"")),!r[0].length)return!1;r[0]=r[0].toLowerCase(),r[1]="gmail.com"}else t.lowercase&&(r[0]=r[0].toLowerCase());return r.join("@")}for(var ce,pe="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol?"symbol":typeof e},ge={require_tld:!0,allow_underscores:!1,allow_trailing_dot:!1},Fe={allow_display_name:!1,allow_utf8_local_part:!0,require_tld:!0},ve=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\.\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\.\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF\s]*<(.+)>$/i,_e=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~]+$/i,he=/^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f]))*$/i,$e=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+$/i,xe=/^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))*$/i,Ae=/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/,me=/^[0-9A-F]{1,4}$/i,we={protocols:["http","https","ftp"],require_tld:!0,require_protocol:!1,require_host:!0,require_valid_protocol:!0,allow_underscores:!1,allow_trailing_dot:!1,allow_protocol_relative_urls:!1},be=/^\[([^\]]+)\](?::([0-9]+))?$/,ye=/^([0-9a-fA-F][0-9a-fA-F]:){5}([0-9a-fA-F][0-9a-fA-F])$/,De={"en-US":/^[A-Z]+$/i,"cs-CZ":/^[A-ZÁČĎÉĚÍŇÓŘŠŤÚŮÝŽ]+$/i,"de-DE":/^[A-ZÄÖÜß]+$/i,"es-ES":/^[A-ZÁÉÍÑÓÚÜ]+$/i,"fr-FR":/^[A-ZÀÂÆÇÉÈÊËÏÎÔŒÙÛÜŸ]+$/i,"nl-NL":/^[A-ZÉËÏÓÖÜ]+$/i,"hu-HU":/^[A-ZÁÉÍÓÖŐÚÜŰ]+$/i,"pl-PL":/^[A-ZĄĆĘŚŁŃÓŻŹ]+$/i,"pt-PT":/^[A-ZÃÁÀÂÇÉÊÍÕÓÔÚÜ]+$/i,"ru-RU":/^[А-ЯЁ]+$/i,"sr-RS@latin":/^[A-ZČĆŽŠĐ]+$/i,"sr-RS":/^[А-ЯЂЈЉЊЋЏ]+$/i,"tr-TR":/^[A-ZÇĞİıÖŞÜ]+$/i,ar:/^[ءآأؤإئابةتثجحخدذرزسشصضطظعغفقكلمنهوىيًٌٍَُِّْٰ]+$/},Se={"en-US":/^[0-9A-Z]+$/i,"cs-CZ":/^[0-9A-ZÁČĎÉĚÍŇÓŘŠŤÚŮÝŽ]+$/i,"de-DE":/^[0-9A-ZÄÖÜß]+$/i,"es-ES":/^[0-9A-ZÁÉÍÑÓÚÜ]+$/i,"fr-FR":/^[0-9A-ZÀÂÆÇÉÈÊËÏÎÔŒÙÛÜŸ]+$/i,"hu-HU":/^[0-9A-ZÁÉÍÓÖŐÚÜŰ]+$/i,"nl-NL":/^[0-9A-ZÉËÏÓÖÜ]+$/i,"pl-PL":/^[0-9A-ZĄĆĘŚŁŃÓŻŹ]+$/i,"pt-PT":/^[0-9A-ZÃÁÀÂÇÉÊÍÕÓÔÚÜ]+$/i,"ru-RU":/^[0-9А-ЯЁ]+$/i,"sr-RS@latin":/^[0-9A-ZČĆŽŠĐ]+$/i,"sr-RS":/^[0-9А-ЯЂЈЉЊЋЏ]+$/i,"tr-TR":/^[0-9A-ZÇĞİıÖŞÜ]+$/i,ar:/^[٠١٢٣٤٥٦٧٨٩0-9ءآأؤإئابةتثجحخدذرزسشصضطظعغفقكلمنهوىيًٌٍَُِّْٰ]+$/},Ze=["AU","GB","HK","IN","NZ","ZA","ZM"],Ee=0;Ee<Ze.length;Ee++)ce="en-"+Ze[Ee],De[ce]=De["en-US"],Se[ce]=Se["en-US"];De["pt-BR"]=De["pt-PT"],Se["pt-BR"]=Se["pt-PT"];for(var Ie,Oe=["AE","BH","DZ","EG","IQ","JO","KW","LB","LY","MA","QM","QA","SA","SD","SY","TN","YE"],Re=0;Re<Oe.length;Re++)Ie="ar-"+Oe[Re],De[Ie]=De.ar,Se[Ie]=Se.ar;var Ce=/^[-+]?[0-9]+$/,Ne=/^[\x00-\x7F]+$/,je=/[^\u0020-\u007E\uFF61-\uFF9F\uFFA0-\uFFDC\uFFE8-\uFFEE0-9a-zA-Z]/,Ue=/[\u0020-\u007E\uFF61-\uFF9F\uFFA0-\uFFDC\uFFE8-\uFFEE0-9a-zA-Z]/,ze=/[^\x00-\x7F]/,Be=/[\uD800-\uDBFF][\uDC00-\uDFFF]/,Le=/^(?:[-+]?(?:0|[1-9][0-9]*))$/,Pe=/^[-+]?[0-9]+$/,qe=/^(?:[-+]?(?:[0-9]+))?(?:\.[0-9]*)?(?:[eE][\+\-]?(?:[0-9]+))?$/,Te=/^[-+]?([0-9]+|\.[0-9]+|[0-9]+\.[0-9]+)$/,Me=/^[0-9A-F]+$/i,He=/^#?([0-9A-F]{3}|[0-9A-F]{6})$/i,We=/^[a-f0-9]{32}$/,Ye={3:/^[0-9A-F]{8}-[0-9A-F]{4}-3[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,4:/^[0-9A-F]{8}-[0-9A-F]{4}-4[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,5:/^[0-9A-F]{8}-[0-9A-F]{4}-5[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,all:/^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i},Ge=/^([\+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([\.,]\d+(?!:))?)?(\17[0-5]\d([\.,]\d+)?)?([zZ]|([\+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/,Je=/^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|(222[1-9]|22[3-9][0-9]|2[3-6][0-9]{2}|27[01][0-9]|2720)[0-9]{12}|6(?:011|5[0-9][0-9])[0-9]{12}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|(?:2131|1800|35\d{3})\d{11})|62[0-9]{14}$/,Ke=/^[A-Z]{2}[0-9A-Z]{9}[0-9]$/,Qe=/^(?:[0-9]{9}X|[0-9]{10})$/,ke=/^(?:[0-9]{13})$/,Ve=[1,3],Xe={"ar-DZ":/^(\+?213|0)(5|6|7)\d{8}$/,"ar-SY":/^(!?(\+?963)|0)?9\d{8}$/,"ar-SA":/^(!?(\+?966)|0)?5\d{8}$/,"en-US":/^(\+?1)?[2-9]\d{2}[2-9](?!11)\d{6}$/,"cs-CZ":/^(\+?420)? ?[1-9][0-9]{2} ?[0-9]{3} ?[0-9]{3}$/,"de-DE":/^(\+?49[ \.\-])?([\(]{1}[0-9]{1,6}[\)])?([0-9 \.\-\/]{3,20})((x|ext|extension)[ ]?[0-9]{1,4})?$/,"da-DK":/^(\+?45)?(\d{8})$/,"el-GR":/^(\+?30)?(69\d{8})$/,"en-AU":/^(\+?61|0)4\d{8}$/,"en-GB":/^(\+?44|0)7\d{9}$/,"en-HK":/^(\+?852\-?)?[569]\d{3}\-?\d{4}$/,"en-IN":/^(\+?91|0)?[789]\d{9}$/,"en-NZ":/^(\+?64|0)2\d{7,9}$/,"en-ZA":/^(\+?27|0)\d{9}$/,"en-ZM":/^(\+?26)?09[567]\d{7}$/,"es-ES":/^(\+?34)?(6\d{1}|7[1234])\d{7}$/,"fi-FI":/^(\+?358|0)\s?(4(0|1|2|4|5)?|50)\s?(\d\s?){4,8}\d$/,"fr-FR":/^(\+?33|0)[67]\d{8}$/,"hu-HU":/^(\+?36)(20|30|70)\d{7}$/,"it-IT":/^(\+?39)?\s?3\d{2} ?\d{6,7}$/,"ja-JP":/^(\+?81|0)\d{1,4}[ \-]?\d{1,4}[ \-]?\d{4}$/,"ms-MY":/^(\+?6?01){1}(([145]{1}(\-|\s)?\d{7,8})|([236789]{1}(\s|\-)?\d{7}))$/,"nb-NO":/^(\+?47)?[49]\d{7}$/,"nl-BE":/^(\+?32|0)4?\d{8}$/,"nn-NO":/^(\+?47)?[49]\d{7}$/,"pl-PL":/^(\+?48)? ?[5-8]\d ?\d{3} ?\d{2} ?\d{2}$/,"pt-BR":/^(\+?55|0)\-?[1-9]{2}\-?[2-9]{1}\d{3,4}\-?\d{4}$/,"pt-PT":/^(\+?351)?9[1236]\d{7}$/,"ru-RU":/^(\+?7|8)?9\d{9}$/,"sr-RS":/^(\+3816|06)[- \d]{5,9}$/,"tr-TR":/^(\+?90|0)?5\d{9}$/,"vi-VN":/^(\+?84|0)?((1(2([0-9])|6([2-9])|88|99))|(9((?!5)[0-9])))([0-9]{7})$/,"zh-CN":/^(\+?0?86\-?)?1[345789]\d{9}$/,"zh-TW":/^(\+?886\-?|0)?9\d{8}$/};Xe["en-CA"]=Xe["en-US"],Xe["fr-BE"]=Xe["nl-BE"];var et={symbol:"$",require_symbol:!1,allow_space_after_symbol:!1,symbol_after_digits:!1,allow_negatives:!0,parens_for_negatives:!1,negative_sign_before_digits:!1,negative_sign_after_digits:!1,allow_negative_sign_placeholder:!1,thousands_separator:",",decimal_separator:".",allow_space_after_digits:!1},tt=/[^A-Z0-9+\/=]/i,rt=/^\s*data:([a-z]+\/[a-z0-9\-\+]+(;[a-z\-]+=[a-z0-9\-]+)?)?(;base64)?,[a-z0-9!\$&',\(\)\*\+,;=\-\._~:@\/\?%\s]*\s*$/i,nt={lowercase:!0,remove_dots:!0,remove_extension:!0},it="5.7.0",ot={version:it,toDate:t,toFloat:r,toInt:n,toBoolean:i,equals:o,contains:u,matches:s,isEmail:c,isURL:v,isMACAddress:_,isIP:p,isFQDN:d,isBoolean:h,isAlpha:$,isAlphanumeric:x,isNumeric:A,isLowercase:m,isUppercase:w,isAscii:b,isFullWidth:y,isHalfWidth:D,isVariableWidth:S,isMultibyte:Z,isSurrogatePair:E,isInt:I,isFloat:O,isDecimal:R,isHexadecimal:C,isDivisibleBy:N,isHexColor:j,isMD5:U,isJSON:z,isNull:B,isLength:L,isByteLength:f,isUUID:P,isMongoId:q,isDate:H,isAfter:W,isBefore:Y,isIn:G,isCreditCard:J,isISIN:K,isISBN:Q,isMobilePhone:k,isCurrency:X,isISO8601:T,isBase64:ee,isDataURI:te,ltrim:re,rtrim:ne,trim:ie,escape:oe,unescape:ae,stripLow:se,whitelist:le,blacklist:ue,isWhitelisted:fe,normalizeEmail:de,toString:a};return ot});